
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Payroll_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const payroll_items = await db.payroll_items.create(
            {
                id: data.id || undefined,
        
        gross_pay: data.gross_pay
        ||
        null
            ,
            
        deductions: data.deductions
        ||
        null
            ,
            
        net_pay: data.net_pay
        ||
        null
            ,
            
        commission_amount: data.commission_amount
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await payroll_items.setPayroll_run( data.payroll_run || null, {
            transaction,
        });
        
        await payroll_items.setEmployee( data.employee || null, {
            transaction,
        });
        
        await payroll_items.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return payroll_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const payroll_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                gross_pay: item.gross_pay
            ||
            null
            ,
            
                deductions: item.deductions
            ||
            null
            ,
            
                net_pay: item.net_pay
            ||
            null
            ,
            
                commission_amount: item.commission_amount
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const payroll_items = await db.payroll_items.bulkCreate(payroll_itemsData, { transaction });

        // For each item created, replace relation files
        

        return payroll_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const payroll_items = await db.payroll_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.gross_pay !== undefined) updatePayload.gross_pay = data.gross_pay;
        
        
        if (data.deductions !== undefined) updatePayload.deductions = data.deductions;
        
        
        if (data.net_pay !== undefined) updatePayload.net_pay = data.net_pay;
        
        
        if (data.commission_amount !== undefined) updatePayload.commission_amount = data.commission_amount;
        
        
        updatePayload.updatedById = currentUser.id;

        await payroll_items.update(updatePayload, {transaction});

        
        
        if (data.payroll_run !== undefined) {
            await payroll_items.setPayroll_run(
              
              data.payroll_run,
              
              { transaction }
            );
        }
        
        if (data.employee !== undefined) {
            await payroll_items.setEmployee(
              
              data.employee,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await payroll_items.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return payroll_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const payroll_items = await db.payroll_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of payroll_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of payroll_items) {
                await record.destroy({transaction});
            }
        });


        return payroll_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const payroll_items = await db.payroll_items.findByPk(id, options);

        await payroll_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await payroll_items.destroy({
            transaction
        });

        return payroll_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const payroll_items = await db.payroll_items.findOne(
            { where },
            { transaction },
        );

        if (!payroll_items) {
            return payroll_items;
        }

        const output = payroll_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.payroll_run = await payroll_items.getPayroll_run({
            transaction
        });
        
        
        output.employee = await payroll_items.getEmployee({
            transaction
        });
        
        
        output.organizations = await payroll_items.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.payroll_runs,
        as: 'payroll_run',
        
        where: filter.payroll_run ? {
          [Op.or]: [
            { id: { [Op.in]: filter.payroll_run.split('|').map(term => Utils.uuid(term)) } },
            {
              payroll_name: {
                [Op.or]: filter.payroll_run.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.employees,
        as: 'employee',
        
        where: filter.employee ? {
          [Op.or]: [
            { id: { [Op.in]: filter.employee.split('|').map(term => Utils.uuid(term)) } },
            {
              employee_number: {
                [Op.or]: filter.employee.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.gross_payRange) {
                const [start, end] = filter.gross_payRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    gross_pay: {
                    ...where.gross_pay,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    gross_pay: {
                    ...where.gross_pay,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.deductionsRange) {
                const [start, end] = filter.deductionsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    deductions: {
                    ...where.deductions,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    deductions: {
                    ...where.deductions,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.net_payRange) {
                const [start, end] = filter.net_payRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    net_pay: {
                    ...where.net_pay,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    net_pay: {
                    ...where.net_pay,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.commission_amountRange) {
                const [start, end] = filter.commission_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    commission_amount: {
                    ...where.commission_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    commission_amount: {
                    ...where.commission_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.payroll_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'payroll_items',
                        'net_pay',
                        query,
                    ),
                ],
            };
        }

        const records = await db.payroll_items.findAll({
            attributes: [ 'id', 'net_pay' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['net_pay', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.net_pay,
        }));
    }

    
};

